searchNodes=[{"doc":"Elixir introduces into the world of CS, the &quot;multiverse testing&quot; pattern. This is a pattern where tests are run concurrently and each test sees a shard of global state. Examples: Mox: each test has access to the global module mock, sharded by the pid of the running test. Ecto: each test has access to a &quot;database sandbox&quot;, which is a checked out transaction on the global database that acts as its own database shard. Hound,Wallaby: each test generates an ID that is passed outside of the BEAM that is reintercepted on ingress, this ID is then used to connect ecto sandboxes to the parent test PID This library implements Multiverses-aware versions of several constructs in the Elixir Standard Library which aren&#39;t natively Multiversable. For plugins that are provided for other systems, see the libraries: :multiverses_finch - which extends this to HTTP requests that exit the BEAM. :multiverses_pubsub - which extends this to Phoenix.PubSub Usage In mix.exs, you should add the following directive: {:multiverses, &quot;~&gt; 0.4.1&quot;, runtime: false} In your module where you&#39;ll be using at least one multiverse module, use the following header: use Multiverses, with: Registry this aliases Multiverses.Registry to Registry and activates the Multiverses.Registry macros across this module. As an escape hatch, if you need to use the underlying module, you may use the macro alias Elixir.Registry If you need more complex choices for when to activate Multiverses (such as system environment variables), you should encode those choices directly using logic around the use Multiverses statement. Options :with the names of multiverse modules you&#39;d like to use. May be a single module or a list of modules. Is identical to require Multiverses.&lt;module&gt;; alias Multiverses.&lt;module&gt;. :otp_app the otp_app must have its :use_multiverses application environment variable set in order to be used.","ref":"Multiverses.html","title":"Multiverses","type":"module"},{"doc":"purges the caller list.","ref":"Multiverses.html#drop/0","title":"Multiverses.drop/0","type":"macro"},{"doc":"generates a &quot;link&quot; to current universe. If you pass the result of &quot;link&quot; to port/1, then it will bring the ported process into the universe of the process that called link/0","ref":"Multiverses.html#link/0","title":"Multiverses.link/0","type":"macro"},{"doc":"causes the current process to adopt the universe referred to by the result of a link/0 call.","ref":"Multiverses.html#port/1","title":"Multiverses.port/1","type":"macro"},{"doc":"identifies the universe of the current process.","ref":"Multiverses.html#self/0","title":"Multiverses.self/0","type":"macro"},{"doc":"","ref":"Multiverses.html#t:link/0","title":"Multiverses.link/0","type":"opaque"},{"doc":"This module is intended to be a drop-in replacement for DynamicSupervisor. It labels a supervised Multiverses.GenServer with the appropriate universe. Currently uses DynamicSupervisor private API, so forward compatibility is not guaranteed. Usage you should only use this at the point of starting a child under the supervisor. All other uses of DynamicSupervisor (such as use DynamicSupervisor) should use the native Elixir DynamicSupervisor module, and the supervisor is fully compatible with native DynamicSupervisor processes. Notes currently, only start_child/2 is overloaded to provide sharded information. count_children/1, terminate_child/1 and which_children/1 will act on the global information. If you need access to partitioned collections of processes, use Multiverse.Registry.","ref":"Multiverses.DynamicSupervisor.html","title":"Multiverses.DynamicSupervisor","type":"module"},{"doc":"cloned from DynamicSupervisor.__struct__/0","ref":"Multiverses.DynamicSupervisor.html#__struct__/0","title":"Multiverses.DynamicSupervisor.__struct__/0","type":"macro"},{"doc":"cloned from DynamicSupervisor.__struct__/1","ref":"Multiverses.DynamicSupervisor.html#__struct__/1","title":"Multiverses.DynamicSupervisor.__struct__/1","type":"macro"},{"doc":"cloned from DynamicSupervisor.child_spec/1","ref":"Multiverses.DynamicSupervisor.html#child_spec/1","title":"Multiverses.DynamicSupervisor.child_spec/1","type":"macro"},{"doc":"cloned from DynamicSupervisor.code_change/3","ref":"Multiverses.DynamicSupervisor.html#code_change/3","title":"Multiverses.DynamicSupervisor.code_change/3","type":"macro"},{"doc":"cloned from DynamicSupervisor.count_children/1","ref":"Multiverses.DynamicSupervisor.html#count_children/1","title":"Multiverses.DynamicSupervisor.count_children/1","type":"macro"},{"doc":"cloned from DynamicSupervisor.format_report/1","ref":"Multiverses.DynamicSupervisor.html#format_report/1","title":"Multiverses.DynamicSupervisor.format_report/1","type":"macro"},{"doc":"cloned from DynamicSupervisor.format_status/2","ref":"Multiverses.DynamicSupervisor.html#format_status/2","title":"Multiverses.DynamicSupervisor.format_status/2","type":"macro"},{"doc":"cloned from DynamicSupervisor.handle_call/3","ref":"Multiverses.DynamicSupervisor.html#handle_call/3","title":"Multiverses.DynamicSupervisor.handle_call/3","type":"macro"},{"doc":"cloned from DynamicSupervisor.handle_cast/2","ref":"Multiverses.DynamicSupervisor.html#handle_cast/2","title":"Multiverses.DynamicSupervisor.handle_cast/2","type":"macro"},{"doc":"cloned from DynamicSupervisor.handle_info/2","ref":"Multiverses.DynamicSupervisor.html#handle_info/2","title":"Multiverses.DynamicSupervisor.handle_info/2","type":"macro"},{"doc":"cloned from DynamicSupervisor.init/1","ref":"Multiverses.DynamicSupervisor.html#init/1","title":"Multiverses.DynamicSupervisor.init/1","type":"macro"},{"doc":"","ref":"Multiverses.DynamicSupervisor.html#start_child/2","title":"Multiverses.DynamicSupervisor.start_child/2","type":"macro"},{"doc":"cloned from DynamicSupervisor.start_link/1","ref":"Multiverses.DynamicSupervisor.html#start_link/1","title":"Multiverses.DynamicSupervisor.start_link/1","type":"macro"},{"doc":"cloned from DynamicSupervisor.start_link/2","ref":"Multiverses.DynamicSupervisor.html#start_link/2","title":"Multiverses.DynamicSupervisor.start_link/2","type":"macro"},{"doc":"cloned from DynamicSupervisor.start_link/3","ref":"Multiverses.DynamicSupervisor.html#start_link/3","title":"Multiverses.DynamicSupervisor.start_link/3","type":"macro"},{"doc":"cloned from DynamicSupervisor.stop/1","ref":"Multiverses.DynamicSupervisor.html#stop/1","title":"Multiverses.DynamicSupervisor.stop/1","type":"macro"},{"doc":"cloned from DynamicSupervisor.stop/2","ref":"Multiverses.DynamicSupervisor.html#stop/2","title":"Multiverses.DynamicSupervisor.stop/2","type":"macro"},{"doc":"cloned from DynamicSupervisor.stop/3","ref":"Multiverses.DynamicSupervisor.html#stop/3","title":"Multiverses.DynamicSupervisor.stop/3","type":"macro"},{"doc":"cloned from DynamicSupervisor.terminate/2","ref":"Multiverses.DynamicSupervisor.html#terminate/2","title":"Multiverses.DynamicSupervisor.terminate/2","type":"macro"},{"doc":"cloned from DynamicSupervisor.terminate_child/2","ref":"Multiverses.DynamicSupervisor.html#terminate_child/2","title":"Multiverses.DynamicSupervisor.terminate_child/2","type":"macro"},{"doc":"cloned from DynamicSupervisor.which_children/1","ref":"Multiverses.DynamicSupervisor.html#which_children/1","title":"Multiverses.DynamicSupervisor.which_children/1","type":"macro"},{"doc":"This module is intended to be a drop-in replacement for GenServer. When a GenServer process is created by this module, it inherits the callers chain of its parent, in the same way that Important: Typically you won&#39;t want GenServers to default to be part of a multiverse shard, as they generally represent stateful persistent internal services. If the service can exist before and after the test, then you should NOT use this module. When you should use this module: In some cases, a GenServer will represent a transient connection, or a cache for state IRL which is tracked in a specific context.","ref":"Multiverses.GenServer.html","title":"Multiverses.GenServer","type":"module"},{"doc":"cloned from GenServer.abcast/2","ref":"Multiverses.GenServer.html#abcast/2","title":"Multiverses.GenServer.abcast/2","type":"macro"},{"doc":"cloned from GenServer.abcast/3","ref":"Multiverses.GenServer.html#abcast/3","title":"Multiverses.GenServer.abcast/3","type":"macro"},{"doc":"cloned from GenServer.call/2","ref":"Multiverses.GenServer.html#call/2","title":"Multiverses.GenServer.call/2","type":"macro"},{"doc":"cloned from GenServer.call/3","ref":"Multiverses.GenServer.html#call/3","title":"Multiverses.GenServer.call/3","type":"macro"},{"doc":"cloned from GenServer.cast/2","ref":"Multiverses.GenServer.html#cast/2","title":"Multiverses.GenServer.cast/2","type":"macro"},{"doc":"cloned from GenServer.format_report/1","ref":"Multiverses.GenServer.html#format_report/1","title":"Multiverses.GenServer.format_report/1","type":"macro"},{"doc":"cloned from GenServer.multi_call/2","ref":"Multiverses.GenServer.html#multi_call/2","title":"Multiverses.GenServer.multi_call/2","type":"macro"},{"doc":"cloned from GenServer.multi_call/3","ref":"Multiverses.GenServer.html#multi_call/3","title":"Multiverses.GenServer.multi_call/3","type":"macro"},{"doc":"cloned from GenServer.multi_call/4","ref":"Multiverses.GenServer.html#multi_call/4","title":"Multiverses.GenServer.multi_call/4","type":"macro"},{"doc":"cloned from GenServer.reply/2","ref":"Multiverses.GenServer.html#reply/2","title":"Multiverses.GenServer.reply/2","type":"macro"},{"doc":"starts a GenServer, linked to the calling function.","ref":"Multiverses.GenServer.html#start/3","title":"Multiverses.GenServer.start/3","type":"macro"},{"doc":"starts a GenServer, linked to the calling function.","ref":"Multiverses.GenServer.html#start_link/3","title":"Multiverses.GenServer.start_link/3","type":"macro"},{"doc":"cloned from GenServer.stop/1","ref":"Multiverses.GenServer.html#stop/1","title":"Multiverses.GenServer.stop/1","type":"macro"},{"doc":"cloned from GenServer.stop/2","ref":"Multiverses.GenServer.html#stop/2","title":"Multiverses.GenServer.stop/2","type":"macro"},{"doc":"cloned from GenServer.stop/3","ref":"Multiverses.GenServer.html#stop/3","title":"Multiverses.GenServer.stop/3","type":"macro"},{"doc":"cloned from GenServer.whereis/1","ref":"Multiverses.GenServer.html#whereis/1","title":"Multiverses.GenServer.whereis/1","type":"macro"},{"doc":"allows a module to directly clone all of the public functions of a given module, except as macros. thus multiverse equivalents replicate the functionality of the parent module, except with the equivalents substituted at compile time, allowing multiverse apps to exist as [runtime: false] apps. Usage In the following example, FooModule has all of its functions ported into the current module, except as macros. The functions FooModule.foo/3 and FooModule.foo/4 are not, but rather should be ported using defclone/2 use Multiverses.MacroClone, with: FooModule, except: [ foo: 3, foo: 4 ]","ref":"Multiverses.MacroClone.html","title":"Multiverses.MacroClone","type":"module"},{"doc":"clones the target function from the parent module (as defined in the use statement) as a macro, unless use Multiverses has been activated. In the case that use Multiverses has been activated, the macro takes the value of the contents inside the defclone block.","ref":"Multiverses.MacroClone.html#defclone/2","title":"Multiverses.MacroClone.defclone/2","type":"macro"},{"doc":"This module is intended to be a drop-in replacement for Registry, though currently not all functionality is implemented. Unimplemented functionality: count_match/3,4 match/3,4 unregister_match/3,4","ref":"Multiverses.Registry.html","title":"Multiverses.Registry","type":"module"},{"doc":"cloned from Registry.__unregister__/3","ref":"Multiverses.Registry.html#__unregister__/3","title":"Multiverses.Registry.__unregister__/3","type":"macro"},{"doc":"cloned from Registry.child_spec/1","ref":"Multiverses.Registry.html#child_spec/1","title":"Multiverses.Registry.child_spec/1","type":"macro"},{"doc":"","ref":"Multiverses.Registry.html#count/1","title":"Multiverses.Registry.count/1","type":"macro"},{"doc":"cloned from Registry.count_match/3","ref":"Multiverses.Registry.html#count_match/3","title":"Multiverses.Registry.count_match/3","type":"macro"},{"doc":"cloned from Registry.count_match/4","ref":"Multiverses.Registry.html#count_match/4","title":"Multiverses.Registry.count_match/4","type":"macro"},{"doc":"","ref":"Multiverses.Registry.html#dispatch/4","title":"Multiverses.Registry.dispatch/4","type":"macro"},{"doc":"","ref":"Multiverses.Registry.html#keys/2","title":"Multiverses.Registry.keys/2","type":"macro"},{"doc":"","ref":"Multiverses.Registry.html#lookup/2","title":"Multiverses.Registry.lookup/2","type":"macro"},{"doc":"cloned from Registry.match/3","ref":"Multiverses.Registry.html#match/3","title":"Multiverses.Registry.match/3","type":"macro"},{"doc":"cloned from Registry.match/4","ref":"Multiverses.Registry.html#match/4","title":"Multiverses.Registry.match/4","type":"macro"},{"doc":"cloned from Registry.meta/2","ref":"Multiverses.Registry.html#meta/2","title":"Multiverses.Registry.meta/2","type":"macro"},{"doc":"cloned from Registry.put_meta/3","ref":"Multiverses.Registry.html#put_meta/3","title":"Multiverses.Registry.put_meta/3","type":"macro"},{"doc":"Registers the calling process with the Registry. Works as Registry.register/3 does.","ref":"Multiverses.Registry.html#register/3","title":"Multiverses.Registry.register/3","type":"macro"},{"doc":"cloned from Registry.register_name/2","ref":"Multiverses.Registry.html#register_name/2","title":"Multiverses.Registry.register_name/2","type":"macro"},{"doc":"","ref":"Multiverses.Registry.html#select/2","title":"Multiverses.Registry.select/2","type":"macro"},{"doc":"cloned from Registry.send/2","ref":"Multiverses.Registry.html#send/2","title":"Multiverses.Registry.send/2","type":"macro"},{"doc":"cloned from Registry.start_link/1","ref":"Multiverses.Registry.html#start_link/1","title":"Multiverses.Registry.start_link/1","type":"macro"},{"doc":"cloned from Registry.start_link/2","ref":"Multiverses.Registry.html#start_link/2","title":"Multiverses.Registry.start_link/2","type":"macro"},{"doc":"cloned from Registry.start_link/3","ref":"Multiverses.Registry.html#start_link/3","title":"Multiverses.Registry.start_link/3","type":"macro"},{"doc":"","ref":"Multiverses.Registry.html#unregister/2","title":"Multiverses.Registry.unregister/2","type":"macro"},{"doc":"cloned from Registry.unregister_match/3","ref":"Multiverses.Registry.html#unregister_match/3","title":"Multiverses.Registry.unregister_match/3","type":"macro"},{"doc":"cloned from Registry.unregister_match/4","ref":"Multiverses.Registry.html#unregister_match/4","title":"Multiverses.Registry.unregister_match/4","type":"macro"},{"doc":"cloned from Registry.unregister_name/1","ref":"Multiverses.Registry.html#unregister_name/1","title":"Multiverses.Registry.unregister_name/1","type":"macro"},{"doc":"","ref":"Multiverses.Registry.html#update_value/3","title":"Multiverses.Registry.update_value/3","type":"macro"},{"doc":"","ref":"Multiverses.Registry.html#via/2","title":"Multiverses.Registry.via/2","type":"macro"},{"doc":"cloned from Registry.whereis_name/1","ref":"Multiverses.Registry.html#whereis_name/1","title":"Multiverses.Registry.whereis_name/1","type":"macro"},{"doc":"","ref":"MultiversesTest.Replicant.html","title":"MultiversesTest.Replicant","type":"module"},{"doc":"allows you to replicate test module multiple times, forcing them to be run concurrently. This helps prove that the system can be run in parallel without issue.","ref":"MultiversesTest.Replicant.html#defmoduler/2","title":"MultiversesTest.Replicant.defmoduler/2","type":"macro"},{"doc":"Multiverses","ref":"readme.html","title":"Multiverses","type":"extras"},{"doc":"Don&#39;t let Mox, Ecto, Hound and Wallaby have ALL the fun! Wubba dubba lub lub!","ref":"readme.html#multiverses-for-elixir","title":"Multiverses - Multiverses for Elixir.","type":"extras"},{"doc":"add a line into the configuration (typically test.exs): config :my_app, use_multiverses: true If you&#39;d like to drop in multiverse sharding for a given module, You should structure your module as follows: defmodule MyModule do use Multiverses, with: Registry def my_function(...) do # uses Multiverses.Registry when enabled. Registry.unegister(...) end end Some modules which change their implementation, may instead activate themselves via the use directive. For example: defmodule MyServer do use Multiverses.GenServer def start_link(_) do # uses Multiverses.GenServer in GenServer. end end","ref":"readme.html#usage","title":"Multiverses - Usage","type":"extras"},{"doc":"you can activate multiple copies of all the tests by passing the REPLICATION system environment variable: REPLICATION=10 mix test will copy the test modules 10 times over, so multiple versions of the same module could possibly run simultaneously.","ref":"readme.html#testing","title":"Multiverses - Testing","type":"extras"},{"doc":"The package can be installed by adding multiverses to your list of dependencies in mix.exs: def deps do [ {:multiverses, &quot;~&gt; 0.4.0&quot;, runtime: false} ] end Documentation can be found at https://hexdocs.pm/multiverses.","ref":"readme.html#installation","title":"Multiverses - Installation","type":"extras"}]